#ifndef _USERWINDOW_H_
#define _USERWINDOW_H_
//=============================================================================
//
//   File : userwindow.h
//   Created on Mon 30 Aug 2004 15:00:52 by Szymon Stefanek
//
//   This file is part of the KVIrc IRC client distribution
//   Copyright (C) 2004 Szymon Stefanek <pragma at kvirc dot net>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include "kvi_settings.h"
#include "kvi_window.h"

class KviUserWindow : public KviWindow
{
	Q_OBJECT
public:
	enum CreationFlags { HasInput = 1 };
public:
	KviUserWindow(KviFrame * pFrm,const char * name,int iIcon,KviConsole * pConsole = 0,int iCreationFlags = 0);
	~KviUserWindow();
protected:
	int m_iIcon;
protected:
	virtual void resizeEvent(QResizeEvent *e);
	virtual QPixmap * myIconPtr();
	virtual void fillCaptionBuffers();
public:
	void setCaptionStrings(const QString &szPlainText,const QString &szHtmlInactive,const QString &szHtmlActive);
};

#endif //!_USERWINDOW_H_
